"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _nullishCoalesce(lhs, rhsFn) { if (lhs != null) { return lhs; } else { return rhsFn(); } } function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }// src/options.ts





var _common = require('@vue-macros/common');
function resolveOptions(options) {
  const version = options.version || _common.detectVueVersion.call(void 0, );
  const lib = options.lib || "vue/vapor";
  return {
    include: [_common.REGEX_SRC_FILE],
    exclude: [_common.REGEX_SETUP_SFC, _common.REGEX_NODE_MODULES],
    ...options,
    version,
    lib,
    defineComponent: {
      alias: _nullishCoalesce(_optionalChain([options, 'optionalAccess', _ => _.defineComponent, 'optionalAccess', _2 => _2.alias]), () => ( [
        "defineComponent",
        "defineVaporComponent"
      ]))
    },
    defineModel: { alias: _nullishCoalesce(_optionalChain([options, 'optionalAccess', _3 => _3.defineModel, 'optionalAccess', _4 => _4.alias]), () => ( ["defineModel"])) },
    defineSlots: { alias: _nullishCoalesce(_optionalChain([options, 'optionalAccess', _5 => _5.defineSlots, 'optionalAccess', _6 => _6.alias]), () => ( ["defineSlots"])) },
    defineExpose: { alias: _nullishCoalesce(_optionalChain([options, 'optionalAccess', _7 => _7.defineExpose, 'optionalAccess', _8 => _8.alias]), () => ( ["defineExpose"])) },
    defineStyle: { alias: _nullishCoalesce(_optionalChain([options, 'optionalAccess', _9 => _9.defineStyle, 'optionalAccess', _10 => _10.alias]), () => ( ["defineStyle"])) }
  };
}



exports.resolveOptions = resolveOptions;
